using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.Warehouse.Cqrs;

public record DeleteWarehouseByIdRequest(string Id);

public record DeleteWarehouseByIdCommand(DeleteWarehouseByIdRequest Data) : IRequest<bool>;

public class DeleteWarehouseByIdHandler : IRequestHandler<DeleteWarehouseByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteWarehouseByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteWarehouseByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.Warehouse
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        if (entity.SystemWarehouse == true)
        {
            return false;
        }

        _context.Warehouse.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}